UNIT Fsrc_cap;

INTERFACE

USES
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

{const
	MaxKeyWords = 62;
	Keywords : array[0..MaxKeywords] of pchar=
  ('and', 'as', 'asm', 'array', 'begin',
	'case', 'class', 'const', 'constructor', 'destructor',
	'div', 'do', 'downto', 'else', 'end',
  'except', 'exports', 'file', 'finally', 'for',
	'function','goto', 'if', 'implementation',  'in',
	'inherited', 'inline', 'initialization', 'interface', 'is',
	'label', 'library', 'mod', 'nil', 'not', 'object',
 	'of', 'or', 'packed','private', 'procedure',
  'program', 'property','protected','public', 'raise',
  'record', 'repeat',  'set', 'shl', 'shr',
  'string', 'then', 'to', 'try', 'type',
  'unit', 'until', 'uses', 'var', 'while',
  'with','xor');}



TYPE
  TForm1 = CLASS(TForm)
    Edit1: TEdit;
    LABEL1: TLabel;
    SpeedButton1: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE SpeedButton1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
  PRIVATE
    { Private declarations }
    Backup 		: STRING;
    KeyWords  : TStringList;
    PROCEDURE UpdatePas;

  PUBLIC
    { Public declarations }
    fIn	: TMemoryStream;
  END;

VAR
  Form1: TForm1;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TForm1.Button1Click(Sender: TObject);
VAR
  per			: byte;
  tmp			: STRING;
BEGIN
	IF Edit1.Text <> '' THEN
  BEGIN
  	Keywords := TStringList.Create;
    TRY
    	{ load the keyword list from the file}
      tmp := Application.ExeName;
      tmp := Copy(tmp, 1, Length(tmp) - 4) + '.lst';
	    Keywords.LoadFromFile(tmp);

      { check for possible pilot error}
      IF Keywords.count = 0 THEN
      BEGIN
      	ShowMessage('No keywords!');
        Exit;
      END;

      { create a stream for in-memory parsing}
			fIn := TMemoryStream.Create;
      { read in the source file}
  		fIn.LoadFromFile(Edit1.Text);

      { create the backup file}
	    Backup 	:= ExtractFileName(Edit1.Text);

      { find the position of the file ext.}
	    per			:= Pos('.', Backup) - 1;
  	  IF Per < 1 THEN per := Length(Backup);

      { create the filename}
    	BackUp 	:= Copy(Backup, 1, Per) +'.~bk';
	    Backup 	:= ExtractFilePath(Edit1.Text)  + Backup;
      { save the original file}
  	  fIn.SaveToFile(Backup);

      { do the prettying}
	  	UpdatePas;
    FINALLY
    	{ free the stringlist}
    	Keywords.free;
    END;
  END
  ELSE ShowMessage('Please select an input file');

END;

PROCEDURE TForm1.UpdatePas;
VAR
	tmpBuf 	: ARRAY [0..200] OF char; {input buffer}
  cmp,i		: Integer;


  { moves the memorystream position pointer past the
  	matching quote, comment character(s)}
	PROCEDURE SkipComment(style: STRING);
  VAR
  	x: byte;
    z: integer;
    ch:char;
  BEGIN
  	x := fIn.Read(ch, 1);
		z := 1;
    WHILE x = 1 DO
    BEGIN
    	IF ch = style[z] THEN inc(z)
      ELSE z:=1;

      IF z > length(Style) THEN exit;

      x := fIn.Read(ch, 1);
    END;
  END;

  { finds the length of a word from the current position
  	of the memory stream}
	FUNCTION FindWordLen: Integer;
  VAR
  	ch 	: char;
    x		: Byte;
  BEGIN
  	result := 0;

    { read in the initial character}
  	x	:= fIn.Read(ch,1);

  	WHILE x = 1  DO	{ loop until a 0 is returned}
    BEGIN
    	{ inspect the character}
    	CASE ch OF
      '(':    {comment or bracket}
      BEGIN
      	IF result > 0 THEN break;

        {read in next char}
        x := fIn.Read(ch, 1);

        { if * then look for the match}
        IF ch = '*' THEN SkipComment('*)')
        ELSE fIn.Seek(-1,1);
      END;

      '{':	{regular comment}
      	IF result = 0 THEN skipcomment('}')
        ELSE break;

      #39:		{ single quote}
      	IF result = 0 THEN skipcomment(ch)
        ELSE break;

      #65..#90,#97..#122: { letter}
        	result := result + 1;

      ELSE {anything else}
      	IF result > 0 THEN break;
      END;

      { get the next character}
      x	:= fIn.Read(ch,1);
    END;

    { move back to the beginning of the word}
    IF result > 0 THEN fIn.Seek((result+1) * -1, 1);
  END;

BEGIN
	{ ok, here we go.  Find the length of the first word}
	cmp := FindWordLen;

  { loop until no words are found}
	WHILE  cmp > 0 DO
  BEGIN
  	{ read the word into a temp buffer}
  	fIn.Read(tmpBuf,cmp);

    { add a null char}
    tmpBuf[cmp] := #0;

    { loop through all the keywords and see if we have any matches}
  	FOR i := 0 TO Keywords.Count - 1 DO
    	IF CompareText(StrPas(tmpBuf), KeyWords[i]) = 0 THEN
      BEGIN
      	{ we found a match so capitalize the buffer}
      	StrUpper (tmpBuf);
        { move back to the beginning of the word}
        fIn.Seek(cmp * -1,1);

        { replace the word with the capitalized version}
        fIn.Write(tmpBuf, cmp);

        { no need to continue looking for a keyword}
        break;
      END;

    { get the next word}
    cmp := FindWordLen;
  END;

  { save the memorystream to the original file}
  fIn.SaveToFile (Edit1.text);

  { say something witty}
  ShowMessage('Finished!!! Original saved as ' +Backup);

END;

PROCEDURE TForm1.SpeedButton1Click(Sender: TObject);
BEGIN
	OpenDialog1.FileName := Edit1.Text;
	IF OpenDialog1.Execute THEN Edit1.text := OpenDialog1.FileName;
END;

PROCEDURE TForm1.Button2Click(Sender: TObject);
BEGIN
	Close;
END;

END.
